//*******************************************************
//	FM channel Radio
//	FM tuner module : SPK-FM-301 / SPK-TFM-1010
//
//	MCU:	ATmega8
//			hfuse:C1h	EEPROMی
//			lfuse:A4h	CR 8MHz BOD 2.7V
//
//	Compiler:	AVR-GCC		4.3.0
//				AVR-LIBC	1.6.2
//				binutils	2.18
//
//	2009.8.17	KAWAKAMI Yukio
//*******************************************************

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned short	ushort;
typedef	unsigned long	ulong;

// |[gݒ
#define		PB7			7	// PORTB
#define		PB6			6
#define		SCK			5
#define		MISO		4
#define		LED4		3
#define		LED3		2
#define		LED2		1
#define		LED1		0

#define		POWER		7	// PORTD
#define		SW4			6
#define		SW3			5
#define		SW2			4
#define		SW1			3
#define		SW0			2
#define		TXD			1
#define		RXD			0

#define		SCL			5	// PORTC
#define		SDA			4
#define		PC3			3
#define		PC2			2
#define		PC1			1
#define		BATT		0


#define		EEPROM_CH			1	// `lԍۑAhX
#define		EEPROM_STEREO_FLAG	2	// XeItO
#define		EEPROM_FREQ_START	8	// gvZbgl̊JnAhX

#define		SW_POWER	0x01
#define		SW_1		0x02
#define		SW_2		0x04
#define		SW_3		0x08
#define		SW_4		0x10

uint	get_freq(uchar ch);
void	set_freq(uint freq);

uchar	check_freq(uint freq);

void	scan_wave(void);
void	power_off(void);
char	check_batt(void);

void	wait_timer(uchar t);

char	TWI_start(void);
char	TWI_send(uchar data);
uchar	TWI_recv(uchar ack);
void	TWI_stop(void);

void	write_AR1000(uchar adrs, ushort data);
ushort	read_AR1000(uchar adrs);
